package dev.shadowsoffire.apotheosis.adventure.affix.salvaging;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.google.common.base.Predicates;
import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingRecipe;
import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingTableTile;
import dev.shadowsoffire.placebo.cap.InternalItemHandler;
import dev.shadowsoffire.placebo.menu.BlockEntityMenu;
import dev.shadowsoffire.placebo.menu.FilteredSlot;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.sounds.SoundSource;
import net.minecraft.util.RandomSource;
import net.minecraft.world.Container;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraftforge.items.IItemHandlerModifiable;
import net.minecraftforge.items.wrapper.RecipeWrapper;

public class SalvagingMenu extends BlockEntityMenu<SalvagingTableTile> {
  protected final Player player;
  
  protected final InternalItemHandler inputInv = new InternalItemHandler(12);
  
  public SalvagingMenu(int id, Inventory inv, BlockPos pos) {
    super((MenuType)Adventure.Menus.SALVAGE.get(), id, inv, pos);
    this.player = inv.f_35978_;
    int leftOffset = 17;
    int topOffset = 17;
    int i;
    for (i = 0; i < 12; i++)
      m_38897_((Slot)new Object(this, this.inputInv, i, leftOffset + i % 4 * 19, topOffset + i / 4 * 19, s -> (findMatch(this.level, s) != null))); 
    for (i = 0; i < 6; i++) {
      leftOffset = 124;
      topOffset = 17;
      m_38897_((Slot)new FilteredSlot(((SalvagingTableTile)this.tile).output, i, leftOffset + i % 2 * 19, topOffset + i / 2 * 19, Predicates.alwaysFalse()));
    } 
    addPlayerSlots(inv, 8, 92);
    this.mover.registerRule((stack, slot) -> (slot.intValue() >= this.playerInvStart && findMatch(this.level, stack) != null), 0, 12);
    this.mover.registerRule((stack, slot) -> (slot.intValue() < this.playerInvStart), this.playerInvStart, this.hotbarStart + 9);
    registerInvShuffleRules();
  }
  
  public boolean m_6875_(Player player) {
    if (this.level.f_46443_)
      return true; 
    return (this.level.m_8055_(this.pos).m_60734_() == Adventure.Blocks.SALVAGING_TABLE.get());
  }
  
  public void m_6877_(Player player) {
    super.m_6877_(player);
    if (!this.level.f_46443_)
      m_150411_(player, (Container)new RecipeWrapper((IItemHandlerModifiable)this.inputInv)); 
  }
  
  public boolean m_6366_(Player player, int id) {
    if (id == 0) {
      salvageAll();
      this.level.m_5594_(null, player.m_20183_(), SoundEvents.f_11862_, SoundSource.BLOCKS, 0.99F, this.level.f_46441_.m_188501_() * 0.25F + 1.0F);
      this.level.m_5594_(null, player.m_20183_(), SoundEvents.f_144054_, SoundSource.BLOCKS, 0.34F, this.level.f_46441_.m_188501_() * 0.2F + 0.8F);
      this.level.m_5594_(null, player.m_20183_(), SoundEvents.f_12471_, SoundSource.BLOCKS, 0.45F, this.level.f_46441_.m_188501_() * 0.5F + 0.75F);
      return true;
    } 
    return super.m_6366_(player, id);
  }
  
  protected void giveItem(Player player, ItemStack stack) {
    if (!player.m_6084_() || (player instanceof ServerPlayer && ((ServerPlayer)player).m_9232_())) {
      player.m_36176_(stack, false);
    } else {
      Inventory inventory = player.m_150109_();
      if (inventory.f_35978_ instanceof ServerPlayer)
        inventory.m_150079_(stack); 
    } 
  }
  
  protected void salvageAll() {
    for (int inSlot = 0; inSlot < 12; inSlot++) {
      Slot s = m_38853_(inSlot);
      ItemStack stack = s.m_7993_();
      List<ItemStack> outputs = salvageItem(this.level, stack);
      s.m_5852_(ItemStack.f_41583_);
      for (ItemStack out : outputs) {
        for (int outSlot = 0; outSlot < 6 && 
          !out.m_41619_(); outSlot++)
          out = ((SalvagingTableTile)this.tile).output.insertItem(outSlot, out, false); 
        if (!out.m_41619_())
          giveItem(this.player, out); 
      } 
    } 
  }
  
  public static int getSalvageCount(SalvagingRecipe.OutputData output, ItemStack stack, RandomSource rand) {
    int[] counts = getSalvageCounts(output, stack);
    return rand.m_216339_(counts[0], counts[1] + 1);
  }
  
  public static int[] getSalvageCounts(SalvagingRecipe.OutputData output, ItemStack stack) {
    int[] out = { output.min, output.max };
    if (stack.m_41763_())
      out[1] = Math.max(out[0], Math.round((out[1] * (stack.m_41776_() - stack.m_41773_()) / stack.m_41776_()))); 
    return out;
  }
  
  public static List<ItemStack> salvageItem(Level level, ItemStack stack) {
    SalvagingRecipe recipe = findMatch(level, stack);
    if (recipe == null)
      return Collections.emptyList(); 
    List<ItemStack> outputs = new ArrayList<>();
    for (SalvagingRecipe.OutputData d : recipe.getOutputs()) {
      ItemStack out = d.stack.m_41777_();
      out.m_41764_(getSalvageCount(d, stack, level.f_46441_));
      outputs.add(out);
    } 
    return outputs;
  }
  
  public static List<ItemStack> getBestPossibleSalvageResults(Level level, ItemStack stack) {
    SalvagingRecipe recipe = findMatch(level, stack);
    if (recipe == null)
      return Collections.emptyList(); 
    List<ItemStack> outputs = new ArrayList<>();
    for (SalvagingRecipe.OutputData d : recipe.getOutputs()) {
      ItemStack out = d.stack.m_41777_();
      out.m_41764_(getSalvageCounts(d, stack)[1]);
      outputs.add(out);
    } 
    return outputs;
  }
  
  @Nullable
  public static SalvagingRecipe findMatch(Level level, ItemStack stack) {
    for (SalvagingRecipe recipe : level.m_7465_().m_44013_(Apoth.RecipeTypes.SALVAGING)) {
      if (recipe.matches(stack))
        return recipe; 
    } 
    return null;
  }
}
